<?php
/* A class that loads a players stats, awards and other info
 *
 * 
 * /ASP/getplayerinfo.aspx?pid=${PID}&info=per*,cmb*,twsc,cpcp,cacp,dfcp,kila,heal,rviv,rsup,rpar,tgte,dkas,dsab,cdsc,rank,cmsc,kick,kill,deth,suic,ospm,klpm,klpr,dtpr,bksk,wdsk,bbrs,tcdr,ban,dtpm,lbtl,osaa,vrk,tsql,tsqm,tlwf,mvks,vmks,mvn*,vmr*,fkit,fmap,fveh,fwea,wtm-,wkl-,wdt-,wac-,wkd-,vtm-,vkl-,vdt-,vkd-,vkr-,atm-,awn-,alo-,abr-,ktm-,kkl-,kdt-,kkd-
 * /ASP/getplayerinfo.aspx?pid=${PID}&info=ktm-,vtm-,wtm-,mtm-&kit=4&vehicle=0&weapon=2&map=4
 * /ASP/getplayerinfo.aspx?pid=${PID}&info=mtm-,mwn-,mls-
 * /ASP/getunlocksinfo.aspx?pid=${PID}
 * /ASP/getrankinfo.aspx?pid=${PID}
 * /ASP/getbackendinfo.aspx
 * /ASP/getawardsinfo.aspx?pid=${PID}
 */
class bf2_player {
	var $_pid = 0;
	var $_nick = false;
	/*
	 * @var array an associative array containing the players stats
	 * @access public
	 */
	var $stats = array();
	/* 
	 * @var bf2_weapons_map an associative array containing a list of weapons and their lock / unlock status
	 * @access public
	 */
	var $unlocks;
	/*
	 * @var bf2_award_map lists the players awards
	 */
	var $awards;
	/*
	 * @var boolean tells whether we were able to load the players info.
	 */
	var $is_valid_player = false;
	function bf2_player($nick=false, $pid = false) {				
		require_once("lib/http.php");
		require_once("bf2_weapon.php");
		require_once("bf2_weapon_map.php");
		require_once("bf2_award_info.php");
		require_once("bf2_award_map.php");
		if(!$nick && !$pid) return;
		$this->_pid = $pid;
		if($nick) {
			$this->unlocks = new bf2_weapons_map();
			$this->_nick = $nick;
			$this->_get_pid();
		}		
		$this->is_valid_player = $this->_pid > 0;
		if($this->is_valid_player) {
			$this->_get_stats();
			//$this->_get_unlocks();
			//$this->_get_awards();
		}
	}
	function _get_stats() {		
		$url = "http://BF2Web.gamespy.com/ASP/getplayerinfo.aspx?pid=".$this->_pid."&info=per*,cmb*,twsc,cpcp,cacp,dfcp,kila,heal,rviv,rsup,rpar,tgte,dkas,dsab,cdsc,rank,cmsc,kick,kill,deth,suic,ospm,klpm,klpr,dtpr,bksk,wdsk,bbrs,tcdr,ban,dtpm,lbtl,osaa,vrk,tsql,tsqm,tlwf,mvks,vmks,mvn*,vmr*,fkit,fmap,fveh,fwea,wtm-,wkl-,wdt-,wac-,wkd-,vtm-,vkl-,vdt-,vkd-,vkr-,atm-,awn-,alo-,abr-,ktm-,kkl-,kdt-,kkd-";
		$results = $this->_query_ea($url);
		$this->stats = $this->_get_result_set($results);
		$url = "";
		
	}	
	function _get_unlocks() {
//		$bed = "";
//		$this->_map_backend_data($bed);
//		$url = "http://BF2Web.gamespy.com/ASP/getunlocksinfo.aspx?pid=".$this->_pid;
	}
	function _get_awards() {
		$url = "http://bf2web.gamespy.com/ASP/getawardsinfo.aspx?pid=".$this->_pid;
		$response = $this->_query_ea($url);
		$this->_build_awards($response);
	}
	function _get_pid() {
		$url = "http://BF2Web.gamespy.com/ASP/searchforplayers.aspx?where=x&nick=".$this->_nick;
		$response = $this->_query_ea($url);
			$result = $this->_get_result_set($response);
			if(isset($result)) {
				$this->_pid = $result['pid'];
			}else {
				$this->_pid = -1;
			}
	}
	function _map_backend_data($str) {
		    /*  CURRENT WEAPON LIST REPORT
		        H	id	kit	name	descr
				D	11	0	Chsht_protecta	Protecta shotgun with slugs
				D	22	1	Usrif_g3a3	H&K G3
				D	33	2	USSHT_Jackhammer	Jackhammer shotgun
				D	44	3	Usrif_sa80	SA-80
				D	55	4	Usrif_g36c	G36C
				D	66	5	RULMG_PKM	PKM
				D	77	6	USSNI_M95_Barret	Barret M82A2 (.50 cal rifle)
				D	88	1	sasrif_fn2000	FN2000
				D	99	2	sasrif_mp7	MP-7
				D	111	3	sasrif_g36e	G36E
				D	222	4	usrif_fnscarl	FN SCAR - L
				D	333	5	sasrif_mg36	MG36
				D	444	0	eurif_fnp90	P90
				D	555	6	gbrif_l96a1	L96A2				
		    */
    	$lines = explode("\n", $str);
		$results = array();
		$line_count = count($lines);
		$line_num = 0;
		$stats = array();
		while ($line_num < $line_count) {
			$next_line = $line_num + 1;
			$line_one = explode("\t", $lines[$line_num]);
			$len = count($line_one);
			if($line_one[0] == '$') {
				break;
			}
			if($line_one[0] == 'O') {
					$line_num++;
					continue;
			}
			if($line_one[0] == 'H') {
				$line_two = explode('	', $lines[$next_line]);
				$line_two_len = count($line_two);
				if($line_two_len > 0 && $line_two[0] == 'D') {				
					for($index = 1; $index <= $len; $index++) {
						if(isset($line_one[$index])) {
							$results[$line_one[$index]] = trim($line_two[$index]);
						}
					}
				}else {
					$line_num++;
					continue;
				}
			}
			$line_num+=2;
		}
		return $results;
	}
	function _query_ea($url) {   	
        $search_request = new http_class();
    	$search_request->timeout = 0;
    	$search_request->data_timeout = 0;
    	$search_request->user_agent="GameSpyHTTP/1.0";
    	$args = null;
    	$error = $search_request->GetRequestArguments($url, $args);
    	if($error != "") {
    		$search_request->Close();
    	    return -1;
    	}	
    	$error = $search_request->Open($args);
    	flush();
    	if($error != "") {
    		$search_request->Close();
    	    return -1;
    	}
    	$search_request->SendRequest($args);
    	flush();
    	$headers = array();
    	$search_request->ReadReplyHeaders($headers);
    	if($search_request->response_status != "200") {
    		$search_request->Close();
    	    return -1;
    	}
    	if($search_request->content_length_set && $search_request->content_length <= 0) {
    		$search_request->Close();
    	    return -1;
    	}
    	$body = false;
    	do {
    		$buffer = 0;
    	    $error=$search_request->ReadReplyBody($buffer, 4096);
    	    $body .= $buffer;
    	}while($error == ""	&& strlen($buffer) != 0);
    	$search_request->Close();
		return $body;		
	}
	function _get_result_set($str) {
    	$lines = explode("\n", $str);
		$results = array();
		$line_count = count($lines);
		$line_num = 0;
		$stats = array();
		while ($line_num < $line_count) {
			$next_line = $line_num + 1;
			$line_one = explode("\t", $lines[$line_num]);
			$len = count($line_one);
			if($line_one[0] != '$') {
				if($line_one[0] == 'O') {
					$line_num++;
					continue;
				}
				else if($line_one[0] == 'H') {
					$line_two = explode('	', $lines[$next_line]);
					$line_two_len = count($line_two);
					if($line_two_len > 0 && $line_two[0] == 'D') {				
						for($index = 1; $index <= $len; $index++) {
							if(isset($line_one[$index])) {
								$results[$line_one[$index]] = trim($line_two[$index]);
							}
						}
					}else {
						$line_num++;
						continue;
					}
				}
				$line_num+=2;
			}else {
				break;
			}
		}
		return $results;
	}
	function _build_awards($str) {
		$awards_map = new bf2_award_map();
    	$lines = explode("\n", $str);
		$results = array();
		$line_count = count($lines);
		$line_num = 0;
		$stats = array();
		while ($line_num < $line_count) {
			$next_line = $line_num + 1;
			$line_one = explode("\t", $lines[$line_num]);
			$len = count($line_one);			
			if($line_one[0] == 'O') {
				$line_num++;
				continue;
			} else if($line_one[0] == 'H') {
			} else if($line_one[0] == '$') {
				break;
			}
			$line_num++;
				
		}
		return $results;
	}
}

?>